// python wrapper for vtkOutputWindow
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkOutputWindow.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkOutputWindow(PyObject *dict); }

static const char *PyvtkOutputWindowCleanup_Doc =
  "vtkOutputWindowCleanup - no description provided.\n\n"

  "vtkOutputWindowCleanup()\n";

static PyMethodDef PyvtkOutputWindowCleanup_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkOutputWindowCleanup_vtkOutputWindowCleanup(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkOutputWindowCleanup");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkOutputWindowCleanup *op = new vtkOutputWindowCleanup();

    result = PyVTKSpecialObject_New("vtkOutputWindowCleanup", op);
  }

  return result;
}

static PyMethodDef PyvtkOutputWindowCleanup_vtkOutputWindowCleanup_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkOutputWindowCleanup_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkOutputWindowCleanup_vtkOutputWindowCleanup(nullptr, args);
}

static void PyvtkOutputWindowCleanup_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkOutputWindowCleanup *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkOutputWindowCleanup_Hash(PyObject *self)
{
#if PY_VERSION_HEX >= 0x020600B2
  return PyObject_HashNotImplemented(self);
#else
  char text[256];
  sprintf(text, "unhashable type: '%s'", Py_TYPE(self)->tp_name);
  PyErr_SetString(PyExc_TypeError, text);
  return -1;
#endif
}

static PyTypeObject PyvtkOutputWindowCleanup_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkCommonCore.vtkOutputWindowCleanup", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkOutputWindowCleanup_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkOutputWindowCleanup_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkOutputWindowCleanup_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkOutputWindowCleanup_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

extern "C" { PyObject *PyvtkOutputWindowCleanup_TypeNew(); }

PyObject *PyvtkOutputWindowCleanup_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkOutputWindowCleanup_Type,
    PyvtkOutputWindowCleanup_Methods,
    PyvtkOutputWindowCleanup_vtkOutputWindowCleanup_Methods,
    nullptr);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

extern "C" { PyObject *PyvtkOutputWindow_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char *PyvtkOutputWindow_Doc =
  "vtkOutputWindow - base class for writing debug output to a console\n\n"
  "Superclass: vtkObject\n\n"
  "This class is used to encapsulate all text output, so that it will\n"
  "work with operating systems that have a stdout and stderr, and ones\n"
  "that do not.  (i.e windows does not).  Sub-classes can be provided\n"
  "which can redirect the output to a window.\n\n";

static PyTypeObject PyvtkOutputWindow_DisplayModes_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkCommonCore.vtkOutputWindow.DisplayModes", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyInt_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

template<class T>
PyObject *PyvtkOutputWindow_DisplayModes_FromEnum(T val)
{
  return PyVTKEnum_New(&PyvtkOutputWindow_DisplayModes_Type, static_cast<int>(val));
}


static PyObject *
PyvtkOutputWindow_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkOutputWindow::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkOutputWindow::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkOutputWindow *tempr = vtkOutputWindow::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkOutputWindow *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkOutputWindow::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_GetInstance(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetInstance");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkOutputWindow *tempr = vtkOutputWindow::GetInstance();

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_SetInstance(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SetInstance");

  vtkOutputWindow *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkOutputWindow"))
  {
    vtkOutputWindow::SetInstance(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_DisplayText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DisplayText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->DisplayText(temp0);
    }
    else
    {
      op->vtkOutputWindow::DisplayText(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_DisplayErrorText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DisplayErrorText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->DisplayErrorText(temp0);
    }
    else
    {
      op->vtkOutputWindow::DisplayErrorText(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_DisplayWarningText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DisplayWarningText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->DisplayWarningText(temp0);
    }
    else
    {
      op->vtkOutputWindow::DisplayWarningText(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_DisplayGenericWarningText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DisplayGenericWarningText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->DisplayGenericWarningText(temp0);
    }
    else
    {
      op->vtkOutputWindow::DisplayGenericWarningText(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_DisplayDebugText(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DisplayDebugText");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->DisplayDebugText(temp0);
    }
    else
    {
      op->vtkOutputWindow::DisplayDebugText(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_PromptUserOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PromptUserOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PromptUserOn();
    }
    else
    {
      op->vtkOutputWindow::PromptUserOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_PromptUserOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PromptUserOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PromptUserOff();
    }
    else
    {
      op->vtkOutputWindow::PromptUserOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_SetPromptUser(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPromptUser");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPromptUser(temp0);
    }
    else
    {
      op->vtkOutputWindow::SetPromptUser(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkOutputWindow_SetUseStdErrorForAllMessages(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseStdErrorForAllMessages");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseStdErrorForAllMessages(temp0);
    }
    else
    {
      op->vtkOutputWindow::SetUseStdErrorForAllMessages(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}
#endif


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkOutputWindow_GetUseStdErrorForAllMessages(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseStdErrorForAllMessages");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseStdErrorForAllMessages() :
      op->vtkOutputWindow::GetUseStdErrorForAllMessages());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}
#endif


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkOutputWindow_UseStdErrorForAllMessagesOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseStdErrorForAllMessagesOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseStdErrorForAllMessagesOn();
    }
    else
    {
      op->vtkOutputWindow::UseStdErrorForAllMessagesOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}
#endif


#if !defined(VTK_LEGACY_REMOVE)
static PyObject *
PyvtkOutputWindow_UseStdErrorForAllMessagesOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseStdErrorForAllMessagesOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseStdErrorForAllMessagesOff();
    }
    else
    {
      op->vtkOutputWindow::UseStdErrorForAllMessagesOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}
#endif


static PyObject *
PyvtkOutputWindow_SetDisplayMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDisplayMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDisplayMode(temp0);
    }
    else
    {
      op->vtkOutputWindow::SetDisplayMode(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_GetDisplayModeMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplayModeMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetDisplayModeMinValue() :
      op->vtkOutputWindow::GetDisplayModeMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_GetDisplayModeMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplayModeMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetDisplayModeMaxValue() :
      op->vtkOutputWindow::GetDisplayModeMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_GetDisplayMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplayMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetDisplayMode() :
      op->vtkOutputWindow::GetDisplayMode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_SetDisplayModeToDefault(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDisplayModeToDefault");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetDisplayModeToDefault();
    }
    else
    {
      op->vtkOutputWindow::SetDisplayModeToDefault();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_SetDisplayModeToNever(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDisplayModeToNever");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetDisplayModeToNever();
    }
    else
    {
      op->vtkOutputWindow::SetDisplayModeToNever();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_SetDisplayModeToAlways(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDisplayModeToAlways");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetDisplayModeToAlways();
    }
    else
    {
      op->vtkOutputWindow::SetDisplayModeToAlways();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkOutputWindow_SetDisplayModeToAlwaysStdErr(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDisplayModeToAlwaysStdErr");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkOutputWindow *op = static_cast<vtkOutputWindow *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetDisplayModeToAlwaysStdErr();
    }
    else
    {
      op->vtkOutputWindow::SetDisplayModeToAlwaysStdErr();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkOutputWindow_Methods[] = {
  {"IsTypeOf", PyvtkOutputWindow_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkOutputWindow_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkOutputWindow_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkOutputWindow\nC++: static vtkOutputWindow *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkOutputWindow_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkOutputWindow\nC++: vtkOutputWindow *NewInstance()\n\n"},
  {"GetInstance", PyvtkOutputWindow_GetInstance, METH_VARARGS,
   "V.GetInstance() -> vtkOutputWindow\nC++: static vtkOutputWindow *GetInstance()\n\nReturn the singleton instance with no reference counting.\n"},
  {"SetInstance", PyvtkOutputWindow_SetInstance, METH_VARARGS,
   "V.SetInstance(vtkOutputWindow)\nC++: static void SetInstance(vtkOutputWindow *instance)\n\nSupply a user defined output window. Call ->Delete() on the\nsupplied instance after setting it.\n"},
  {"DisplayText", PyvtkOutputWindow_DisplayText, METH_VARARGS,
   "V.DisplayText(string)\nC++: virtual void DisplayText(const char *)\n\nDisplay the text. Four virtual methods exist, depending on the\ntype of message to display. This allows redirection or\nreformatting of the messages. The default implementation uses\nDisplayText for all. Consequently, subclasses can simply override\nDisplayText and use `GetCurrentMessageType` to determine the type\nof message that's being reported.\n"},
  {"DisplayErrorText", PyvtkOutputWindow_DisplayErrorText, METH_VARARGS,
   "V.DisplayErrorText(string)\nC++: virtual void DisplayErrorText(const char *)\n\nDisplay the text. Four virtual methods exist, depending on the\ntype of message to display. This allows redirection or\nreformatting of the messages. The default implementation uses\nDisplayText for all. Consequently, subclasses can simply override\nDisplayText and use `GetCurrentMessageType` to determine the type\nof message that's being reported.\n"},
  {"DisplayWarningText", PyvtkOutputWindow_DisplayWarningText, METH_VARARGS,
   "V.DisplayWarningText(string)\nC++: virtual void DisplayWarningText(const char *)\n\nDisplay the text. Four virtual methods exist, depending on the\ntype of message to display. This allows redirection or\nreformatting of the messages. The default implementation uses\nDisplayText for all. Consequently, subclasses can simply override\nDisplayText and use `GetCurrentMessageType` to determine the type\nof message that's being reported.\n"},
  {"DisplayGenericWarningText", PyvtkOutputWindow_DisplayGenericWarningText, METH_VARARGS,
   "V.DisplayGenericWarningText(string)\nC++: virtual void DisplayGenericWarningText(const char *)\n\nDisplay the text. Four virtual methods exist, depending on the\ntype of message to display. This allows redirection or\nreformatting of the messages. The default implementation uses\nDisplayText for all. Consequently, subclasses can simply override\nDisplayText and use `GetCurrentMessageType` to determine the type\nof message that's being reported.\n"},
  {"DisplayDebugText", PyvtkOutputWindow_DisplayDebugText, METH_VARARGS,
   "V.DisplayDebugText(string)\nC++: virtual void DisplayDebugText(const char *)\n\nDisplay the text. Four virtual methods exist, depending on the\ntype of message to display. This allows redirection or\nreformatting of the messages. The default implementation uses\nDisplayText for all. Consequently, subclasses can simply override\nDisplayText and use `GetCurrentMessageType` to determine the type\nof message that's being reported.\n"},
  {"PromptUserOn", PyvtkOutputWindow_PromptUserOn, METH_VARARGS,
   "V.PromptUserOn()\nC++: virtual void PromptUserOn()\n\nIf PromptUser is set to true then each time a line of text is\ndisplayed, the user is asked if they want to keep getting\nmessages.\n\nNote that PromptUser has not effect of messages displayed by\ndirectly calling `DisplayText`. The prompt is never shown for\nsuch messages.\n"},
  {"PromptUserOff", PyvtkOutputWindow_PromptUserOff, METH_VARARGS,
   "V.PromptUserOff()\nC++: virtual void PromptUserOff()\n\nIf PromptUser is set to true then each time a line of text is\ndisplayed, the user is asked if they want to keep getting\nmessages.\n\nNote that PromptUser has not effect of messages displayed by\ndirectly calling `DisplayText`. The prompt is never shown for\nsuch messages.\n"},
  {"SetPromptUser", PyvtkOutputWindow_SetPromptUser, METH_VARARGS,
   "V.SetPromptUser(bool)\nC++: virtual void SetPromptUser(bool _arg)\n\nIf PromptUser is set to true then each time a line of text is\ndisplayed, the user is asked if they want to keep getting\nmessages.\n\nNote that PromptUser has not effect of messages displayed by\ndirectly calling `DisplayText`. The prompt is never shown for\nsuch messages.\n"},
#if !defined(VTK_LEGACY_REMOVE)
  {"SetUseStdErrorForAllMessages", PyvtkOutputWindow_SetUseStdErrorForAllMessages, METH_VARARGS,
   "V.SetUseStdErrorForAllMessages(bool)\nC++: void SetUseStdErrorForAllMessages(bool)\n\nHistorically (VTK 8.1 and earlier), when printing messages to\nterminals, vtkOutputWindow would always post messages to `cerr`.\nSetting this to true restores that incorrect behavior. When false\n(default), vtkOutputWindow uses `cerr` for debug, error and\nwarning messages, and `cout` for text messages.\n\n@deprecated use `SetDisplayModeToAlwaysStdErr` instead.\n"},
#endif
#if !defined(VTK_LEGACY_REMOVE)
  {"GetUseStdErrorForAllMessages", PyvtkOutputWindow_GetUseStdErrorForAllMessages, METH_VARARGS,
   "V.GetUseStdErrorForAllMessages() -> bool\nC++: bool GetUseStdErrorForAllMessages()\n\nHistorically (VTK 8.1 and earlier), when printing messages to\nterminals, vtkOutputWindow would always post messages to `cerr`.\nSetting this to true restores that incorrect behavior. When false\n(default), vtkOutputWindow uses `cerr` for debug, error and\nwarning messages, and `cout` for text messages.\n\n@deprecated use `SetDisplayModeToAlwaysStdErr` instead.\n"},
#endif
#if !defined(VTK_LEGACY_REMOVE)
  {"UseStdErrorForAllMessagesOn", PyvtkOutputWindow_UseStdErrorForAllMessagesOn, METH_VARARGS,
   "V.UseStdErrorForAllMessagesOn()\nC++: void UseStdErrorForAllMessagesOn()\n\nHistorically (VTK 8.1 and earlier), when printing messages to\nterminals, vtkOutputWindow would always post messages to `cerr`.\nSetting this to true restores that incorrect behavior. When false\n(default), vtkOutputWindow uses `cerr` for debug, error and\nwarning messages, and `cout` for text messages.\n\n@deprecated use `SetDisplayModeToAlwaysStdErr` instead.\n"},
#endif
#if !defined(VTK_LEGACY_REMOVE)
  {"UseStdErrorForAllMessagesOff", PyvtkOutputWindow_UseStdErrorForAllMessagesOff, METH_VARARGS,
   "V.UseStdErrorForAllMessagesOff()\nC++: void UseStdErrorForAllMessagesOff()\n\nHistorically (VTK 8.1 and earlier), when printing messages to\nterminals, vtkOutputWindow would always post messages to `cerr`.\nSetting this to true restores that incorrect behavior. When false\n(default), vtkOutputWindow uses `cerr` for debug, error and\nwarning messages, and `cout` for text messages.\n\n@deprecated use `SetDisplayModeToAlwaysStdErr` instead.\n"},
#endif
  {"SetDisplayMode", PyvtkOutputWindow_SetDisplayMode, METH_VARARGS,
   "V.SetDisplayMode(int)\nC++: virtual void SetDisplayMode(int _arg)\n\nFlag indicates how the vtkOutputWindow handles displaying of text\nto `stderr` / `stdout`. Default is `DEFAULT` except in\n`vtkWin32OutputWindow` where on non dashboard runs, the default\nis `NEVER`.\n\n`NEVER` indicates that the messages should never be forwarded to\nthe standard output/error streams.\n\n`ALWAYS` will result in error/warning/debug messages being posted\nto the standard error stream, while text messages to standard\noutput stream.\n\n`ALWAYS_STDERR` will result in all messages being posted to the\nstandard error stream (this was default behavior in VTK 8.1 and\nearlier).\n\n`DEFAULT` is similar to `ALWAYS` except when logging is enabled.\nIf logging is enabled, messages posted to the output window using\nVTK error/warning macros such as `vtkErrorMacro`,\n`vtkWarningMacro` etc. will not posted on any of the output\nstreams. This is done to avoid duplicate messages on these\nstreams since these macros also result in add items to the log.\n\note vtkStringOutputWindow does not result this flag as is never\nforwards any text to the output streams.\n"},
  {"GetDisplayModeMinValue", PyvtkOutputWindow_GetDisplayModeMinValue, METH_VARARGS,
   "V.GetDisplayModeMinValue() -> int\nC++: virtual int GetDisplayModeMinValue()\n\nFlag indicates how the vtkOutputWindow handles displaying of text\nto `stderr` / `stdout`. Default is `DEFAULT` except in\n`vtkWin32OutputWindow` where on non dashboard runs, the default\nis `NEVER`.\n\n`NEVER` indicates that the messages should never be forwarded to\nthe standard output/error streams.\n\n`ALWAYS` will result in error/warning/debug messages being posted\nto the standard error stream, while text messages to standard\noutput stream.\n\n`ALWAYS_STDERR` will result in all messages being posted to the\nstandard error stream (this was default behavior in VTK 8.1 and\nearlier).\n\n`DEFAULT` is similar to `ALWAYS` except when logging is enabled.\nIf logging is enabled, messages posted to the output window using\nVTK error/warning macros such as `vtkErrorMacro`,\n`vtkWarningMacro` etc. will not posted on any of the output\nstreams. This is done to avoid duplicate messages on these\nstreams since these macros also result in add items to the log.\n\note vtkStringOutputWindow does not result this flag as is never\nforwards any text to the output streams.\n"},
  {"GetDisplayModeMaxValue", PyvtkOutputWindow_GetDisplayModeMaxValue, METH_VARARGS,
   "V.GetDisplayModeMaxValue() -> int\nC++: virtual int GetDisplayModeMaxValue()\n\nFlag indicates how the vtkOutputWindow handles displaying of text\nto `stderr` / `stdout`. Default is `DEFAULT` except in\n`vtkWin32OutputWindow` where on non dashboard runs, the default\nis `NEVER`.\n\n`NEVER` indicates that the messages should never be forwarded to\nthe standard output/error streams.\n\n`ALWAYS` will result in error/warning/debug messages being posted\nto the standard error stream, while text messages to standard\noutput stream.\n\n`ALWAYS_STDERR` will result in all messages being posted to the\nstandard error stream (this was default behavior in VTK 8.1 and\nearlier).\n\n`DEFAULT` is similar to `ALWAYS` except when logging is enabled.\nIf logging is enabled, messages posted to the output window using\nVTK error/warning macros such as `vtkErrorMacro`,\n`vtkWarningMacro` etc. will not posted on any of the output\nstreams. This is done to avoid duplicate messages on these\nstreams since these macros also result in add items to the log.\n\note vtkStringOutputWindow does not result this flag as is never\nforwards any text to the output streams.\n"},
  {"GetDisplayMode", PyvtkOutputWindow_GetDisplayMode, METH_VARARGS,
   "V.GetDisplayMode() -> int\nC++: virtual int GetDisplayMode()\n\nFlag indicates how the vtkOutputWindow handles displaying of text\nto `stderr` / `stdout`. Default is `DEFAULT` except in\n`vtkWin32OutputWindow` where on non dashboard runs, the default\nis `NEVER`.\n\n`NEVER` indicates that the messages should never be forwarded to\nthe standard output/error streams.\n\n`ALWAYS` will result in error/warning/debug messages being posted\nto the standard error stream, while text messages to standard\noutput stream.\n\n`ALWAYS_STDERR` will result in all messages being posted to the\nstandard error stream (this was default behavior in VTK 8.1 and\nearlier).\n\n`DEFAULT` is similar to `ALWAYS` except when logging is enabled.\nIf logging is enabled, messages posted to the output window using\nVTK error/warning macros such as `vtkErrorMacro`,\n`vtkWarningMacro` etc. will not posted on any of the output\nstreams. This is done to avoid duplicate messages on these\nstreams since these macros also result in add items to the log.\n\note vtkStringOutputWindow does not result this flag as is never\nforwards any text to the output streams.\n"},
  {"SetDisplayModeToDefault", PyvtkOutputWindow_SetDisplayModeToDefault, METH_VARARGS,
   "V.SetDisplayModeToDefault()\nC++: void SetDisplayModeToDefault()\n\nFlag indicates how the vtkOutputWindow handles displaying of text\nto `stderr` / `stdout`. Default is `DEFAULT` except in\n`vtkWin32OutputWindow` where on non dashboard runs, the default\nis `NEVER`.\n\n`NEVER` indicates that the messages should never be forwarded to\nthe standard output/error streams.\n\n`ALWAYS` will result in error/warning/debug messages being posted\nto the standard error stream, while text messages to standard\noutput stream.\n\n`ALWAYS_STDERR` will result in all messages being posted to the\nstandard error stream (this was default behavior in VTK 8.1 and\nearlier).\n\n`DEFAULT` is similar to `ALWAYS` except when logging is enabled.\nIf logging is enabled, messages posted to the output window using\nVTK error/warning macros such as `vtkErrorMacro`,\n`vtkWarningMacro` etc. will not posted on any of the output\nstreams. This is done to avoid duplicate messages on these\nstreams since these macros also result in add items to the log.\n\note vtkStringOutputWindow does not result this flag as is never\nforwards any text to the output streams.\n"},
  {"SetDisplayModeToNever", PyvtkOutputWindow_SetDisplayModeToNever, METH_VARARGS,
   "V.SetDisplayModeToNever()\nC++: void SetDisplayModeToNever()\n\nFlag indicates how the vtkOutputWindow handles displaying of text\nto `stderr` / `stdout`. Default is `DEFAULT` except in\n`vtkWin32OutputWindow` where on non dashboard runs, the default\nis `NEVER`.\n\n`NEVER` indicates that the messages should never be forwarded to\nthe standard output/error streams.\n\n`ALWAYS` will result in error/warning/debug messages being posted\nto the standard error stream, while text messages to standard\noutput stream.\n\n`ALWAYS_STDERR` will result in all messages being posted to the\nstandard error stream (this was default behavior in VTK 8.1 and\nearlier).\n\n`DEFAULT` is similar to `ALWAYS` except when logging is enabled.\nIf logging is enabled, messages posted to the output window using\nVTK error/warning macros such as `vtkErrorMacro`,\n`vtkWarningMacro` etc. will not posted on any of the output\nstreams. This is done to avoid duplicate messages on these\nstreams since these macros also result in add items to the log.\n\note vtkStringOutputWindow does not result this flag as is never\nforwards any text to the output streams.\n"},
  {"SetDisplayModeToAlways", PyvtkOutputWindow_SetDisplayModeToAlways, METH_VARARGS,
   "V.SetDisplayModeToAlways()\nC++: void SetDisplayModeToAlways()\n\nFlag indicates how the vtkOutputWindow handles displaying of text\nto `stderr` / `stdout`. Default is `DEFAULT` except in\n`vtkWin32OutputWindow` where on non dashboard runs, the default\nis `NEVER`.\n\n`NEVER` indicates that the messages should never be forwarded to\nthe standard output/error streams.\n\n`ALWAYS` will result in error/warning/debug messages being posted\nto the standard error stream, while text messages to standard\noutput stream.\n\n`ALWAYS_STDERR` will result in all messages being posted to the\nstandard error stream (this was default behavior in VTK 8.1 and\nearlier).\n\n`DEFAULT` is similar to `ALWAYS` except when logging is enabled.\nIf logging is enabled, messages posted to the output window using\nVTK error/warning macros such as `vtkErrorMacro`,\n`vtkWarningMacro` etc. will not posted on any of the output\nstreams. This is done to avoid duplicate messages on these\nstreams since these macros also result in add items to the log.\n\note vtkStringOutputWindow does not result this flag as is never\nforwards any text to the output streams.\n"},
  {"SetDisplayModeToAlwaysStdErr", PyvtkOutputWindow_SetDisplayModeToAlwaysStdErr, METH_VARARGS,
   "V.SetDisplayModeToAlwaysStdErr()\nC++: void SetDisplayModeToAlwaysStdErr()\n\nFlag indicates how the vtkOutputWindow handles displaying of text\nto `stderr` / `stdout`. Default is `DEFAULT` except in\n`vtkWin32OutputWindow` where on non dashboard runs, the default\nis `NEVER`.\n\n`NEVER` indicates that the messages should never be forwarded to\nthe standard output/error streams.\n\n`ALWAYS` will result in error/warning/debug messages being posted\nto the standard error stream, while text messages to standard\noutput stream.\n\n`ALWAYS_STDERR` will result in all messages being posted to the\nstandard error stream (this was default behavior in VTK 8.1 and\nearlier).\n\n`DEFAULT` is similar to `ALWAYS` except when logging is enabled.\nIf logging is enabled, messages posted to the output window using\nVTK error/warning macros such as `vtkErrorMacro`,\n`vtkWarningMacro` etc. will not posted on any of the output\nstreams. This is done to avoid duplicate messages on these\nstreams since these macros also result in add items to the log.\n\note vtkStringOutputWindow does not result this flag as is never\nforwards any text to the output streams.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkOutputWindow_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkCommonCore.vtkOutputWindow", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkOutputWindow_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkOutputWindow_StaticNew()
{
  return vtkOutputWindow::New();
}

PyObject *PyvtkOutputWindow_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkOutputWindow_Type, PyvtkOutputWindow_Methods,
    "vtkOutputWindow",
 &PyvtkOutputWindow_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkOutputWindow_DisplayModes_Type);
  PyVTKEnum_Add(&PyvtkOutputWindow_DisplayModes_Type, "vtkOutputWindow.DisplayModes");

  o = (PyObject *)&PyvtkOutputWindow_DisplayModes_Type;
  if (PyDict_SetItemString(d, "DisplayModes", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 4; c++)
  {
    typedef vtkOutputWindow::DisplayModes cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[4] = {
        { "DEFAULT", vtkOutputWindow::DEFAULT },
        { "NEVER", vtkOutputWindow::NEVER },
        { "ALWAYS", vtkOutputWindow::ALWAYS },
        { "ALWAYS_STDERR", vtkOutputWindow::ALWAYS_STDERR },
      };

    o = PyvtkOutputWindow_DisplayModes_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkOutputWindow(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkOutputWindowCleanup_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkOutputWindowCleanup", o) != 0)
  {
    Py_DECREF(o);
  }

  o = PyvtkOutputWindow_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkOutputWindow", o) != 0)
  {
    Py_DECREF(o);
  }

}

