// python wrapper for vtkPVCompositeDataInformationIterator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVCompositeDataInformationIterator.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVCompositeDataInformationIterator(PyObject *dict); }
extern "C" { PyObject *PyvtkPVCompositeDataInformationIterator_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char *PyvtkPVCompositeDataInformationIterator_Doc =
  "vtkPVCompositeDataInformationIterator - iterator used to iterate over\ndata information for a composite data set.\n\n"
  "Superclass: vtkObject\n\n"
  "vtkPVCompositeDataInformationIterator is an iterator used to iterate\n"
  "over data information for a composite data set.\n\n";


static PyObject *
PyvtkPVCompositeDataInformationIterator_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVCompositeDataInformationIterator::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVCompositeDataInformationIterator_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVCompositeDataInformationIterator *op = static_cast<vtkPVCompositeDataInformationIterator *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVCompositeDataInformationIterator::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVCompositeDataInformationIterator_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVCompositeDataInformationIterator *tempr = vtkPVCompositeDataInformationIterator::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVCompositeDataInformationIterator_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVCompositeDataInformationIterator *op = static_cast<vtkPVCompositeDataInformationIterator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVCompositeDataInformationIterator *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVCompositeDataInformationIterator::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVCompositeDataInformationIterator_SetDataInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDataInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVCompositeDataInformationIterator *op = static_cast<vtkPVCompositeDataInformationIterator *>(vp);

  vtkPVDataInformation *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPVDataInformation"))
  {
    if (ap.IsBound())
    {
      op->SetDataInformation(temp0);
    }
    else
    {
      op->vtkPVCompositeDataInformationIterator::SetDataInformation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVCompositeDataInformationIterator_GetDataInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDataInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVCompositeDataInformationIterator *op = static_cast<vtkPVCompositeDataInformationIterator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVDataInformation *tempr = (ap.IsBound() ?
      op->GetDataInformation() :
      op->vtkPVCompositeDataInformationIterator::GetDataInformation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVCompositeDataInformationIterator_InitTraversal(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InitTraversal");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVCompositeDataInformationIterator *op = static_cast<vtkPVCompositeDataInformationIterator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->InitTraversal();
    }
    else
    {
      op->vtkPVCompositeDataInformationIterator::InitTraversal();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVCompositeDataInformationIterator_IsDoneWithTraversal(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsDoneWithTraversal");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVCompositeDataInformationIterator *op = static_cast<vtkPVCompositeDataInformationIterator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsDoneWithTraversal() :
      op->vtkPVCompositeDataInformationIterator::IsDoneWithTraversal());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVCompositeDataInformationIterator_GoToNextItem(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GoToNextItem");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVCompositeDataInformationIterator *op = static_cast<vtkPVCompositeDataInformationIterator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->GoToNextItem();
    }
    else
    {
      op->vtkPVCompositeDataInformationIterator::GoToNextItem();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVCompositeDataInformationIterator_GetCurrentDataInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurrentDataInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVCompositeDataInformationIterator *op = static_cast<vtkPVCompositeDataInformationIterator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVDataInformation *tempr = (ap.IsBound() ?
      op->GetCurrentDataInformation() :
      op->vtkPVCompositeDataInformationIterator::GetCurrentDataInformation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVCompositeDataInformationIterator_GetCurrentName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurrentName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVCompositeDataInformationIterator *op = static_cast<vtkPVCompositeDataInformationIterator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetCurrentName() :
      op->vtkPVCompositeDataInformationIterator::GetCurrentName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVCompositeDataInformationIterator_GetCurrentFlatIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurrentFlatIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVCompositeDataInformationIterator *op = static_cast<vtkPVCompositeDataInformationIterator *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned int tempr = (ap.IsBound() ?
      op->GetCurrentFlatIndex() :
      op->vtkPVCompositeDataInformationIterator::GetCurrentFlatIndex());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPVCompositeDataInformationIterator_Methods[] = {
  {"IsTypeOf", PyvtkPVCompositeDataInformationIterator_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkPVCompositeDataInformationIterator_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkPVCompositeDataInformationIterator_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkPVCompositeDataInformationIterator\nC++: static vtkPVCompositeDataInformationIterator *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVCompositeDataInformationIterator_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVCompositeDataInformationIterator\nC++: vtkPVCompositeDataInformationIterator *NewInstance()\n\n"},
  {"SetDataInformation", PyvtkPVCompositeDataInformationIterator_SetDataInformation, METH_VARARGS,
   "V.SetDataInformation(vtkPVDataInformation)\nC++: void SetDataInformation(vtkPVDataInformation *)\n\nGet/Set the vtkPVDataInformation instance to iterate over. It is\nassumed that the argument represents the data information for a\ncomposite dataset.\n"},
  {"GetDataInformation", PyvtkPVCompositeDataInformationIterator_GetDataInformation, METH_VARARGS,
   "V.GetDataInformation() -> vtkPVDataInformation\nC++: virtual vtkPVDataInformation *GetDataInformation()\n\nGet/Set the vtkPVDataInformation instance to iterate over. It is\nassumed that the argument represents the data information for a\ncomposite dataset.\n"},
  {"InitTraversal", PyvtkPVCompositeDataInformationIterator_InitTraversal, METH_VARARGS,
   "V.InitTraversal()\nC++: void InitTraversal()\n\nInitializes the traversal.\n"},
  {"IsDoneWithTraversal", PyvtkPVCompositeDataInformationIterator_IsDoneWithTraversal, METH_VARARGS,
   "V.IsDoneWithTraversal() -> bool\nC++: bool IsDoneWithTraversal()\n\nReturns true, if the iterator is finished with the traversal.\n"},
  {"GoToNextItem", PyvtkPVCompositeDataInformationIterator_GoToNextItem, METH_VARARGS,
   "V.GoToNextItem()\nC++: void GoToNextItem()\n\nGoes to the next node.\n"},
  {"GetCurrentDataInformation", PyvtkPVCompositeDataInformationIterator_GetCurrentDataInformation, METH_VARARGS,
   "V.GetCurrentDataInformation() -> vtkPVDataInformation\nC++: vtkPVDataInformation *GetCurrentDataInformation()\n\nReturns the current nodes data-information. If current node is a\npiece within a multi-piece dataset, then this will return NULL.\n"},
  {"GetCurrentName", PyvtkPVCompositeDataInformationIterator_GetCurrentName, METH_VARARGS,
   "V.GetCurrentName() -> string\nC++: const char *GetCurrentName()\n\nReturns the name for the current node. Name may be valid only for\na child node. The root node has no name. Returns NULL when no\nname is provided.\n"},
  {"GetCurrentFlatIndex", PyvtkPVCompositeDataInformationIterator_GetCurrentFlatIndex, METH_VARARGS,
   "V.GetCurrentFlatIndex() -> int\nC++: virtual unsigned int GetCurrentFlatIndex()\n\nReturns the current flat index/composite index. This is only\nvalid is IsDoneWithTraversal() returns false.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkPVCompositeDataInformationIterator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkRemotingCore.vtkPVCompositeDataInformationIterator", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkPVCompositeDataInformationIterator_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVCompositeDataInformationIterator_StaticNew()
{
  return vtkPVCompositeDataInformationIterator::New();
}

PyObject *PyvtkPVCompositeDataInformationIterator_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkPVCompositeDataInformationIterator_Type, PyvtkPVCompositeDataInformationIterator_Methods,
    "vtkPVCompositeDataInformationIterator",
 &PyvtkPVCompositeDataInformationIterator_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindClassTypeObject("vtkObject");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkPVCompositeDataInformationIterator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVCompositeDataInformationIterator_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVCompositeDataInformationIterator", o) != 0)
  {
    Py_DECREF(o);
  }

}

