// python wrapper for vtkPVRenderViewDataDeliveryManager
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPVRenderViewDataDeliveryManager.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPVRenderViewDataDeliveryManager(PyObject *dict); }
extern "C" { PyObject *PyvtkPVRenderViewDataDeliveryManager_ClassNew(); }

#ifndef DECLARED_PyvtkPVDataDeliveryManager_ClassNew
extern "C" { PyObject *PyvtkPVDataDeliveryManager_ClassNew(); }
#define DECLARED_PyvtkPVDataDeliveryManager_ClassNew
#endif

static const char *PyvtkPVRenderViewDataDeliveryManager_Doc =
  "vtkPVRenderViewDataDeliveryManager - vtkPVRenderView specific\nsubclass of vtkPVDataDeliveryManager.\n\n"
  "Superclass: vtkPVDataDeliveryManager\n\n"
  "This class adds vtkPVRenderView specific data movement logic to\n"
  "vtkPVDataDeliveryManager.\n\n";


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkPVRenderViewDataDeliveryManager::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPVRenderViewDataDeliveryManager::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkPVRenderViewDataDeliveryManager *tempr = vtkPVRenderViewDataDeliveryManager::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPVRenderViewDataDeliveryManager *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPVRenderViewDataDeliveryManager::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_SetDeliverToAllProcesses(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDeliverToAllProcesses");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  vtkPVDataRepresentation *temp0 = nullptr;
  bool temp1 = false;
  bool temp2 = false;
  int temp3 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(3, 4) &&
      ap.GetVTKObject(temp0, "vtkPVDataRepresentation") &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      (ap.NoArgsLeft() || ap.GetValue(temp3)))
  {
    if (ap.IsBound())
    {
      op->SetDeliverToAllProcesses(temp0, temp1, temp2, temp3);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::SetDeliverToAllProcesses(temp0, temp1, temp2, temp3);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_SetDeliverToClientAndRenderingProcesses(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDeliverToClientAndRenderingProcesses");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  vtkPVDataRepresentation *temp0 = nullptr;
  bool temp1 = false;
  bool temp2 = false;
  bool temp3 = false;
  int temp4 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(4, 5) &&
      ap.GetVTKObject(temp0, "vtkPVDataRepresentation") &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    if (ap.IsBound())
    {
      op->SetDeliverToClientAndRenderingProcesses(temp0, temp1, temp2, temp3, temp4);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::SetDeliverToClientAndRenderingProcesses(temp0, temp1, temp2, temp3, temp4);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_MarkAsRedistributable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MarkAsRedistributable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  vtkPVDataRepresentation *temp0 = nullptr;
  bool temp1 = true;
  int temp2 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 3) &&
      ap.GetVTKObject(temp0, "vtkPVDataRepresentation") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    if (ap.IsBound())
    {
      op->MarkAsRedistributable(temp0, temp1, temp2);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::MarkAsRedistributable(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_SetRedistributionMode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRedistributionMode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  vtkPVDataRepresentation *temp0 = nullptr;
  int temp1;
  int temp2 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetVTKObject(temp0, "vtkPVDataRepresentation") &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    if (ap.IsBound())
    {
      op->SetRedistributionMode(temp0, temp1, temp2);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::SetRedistributionMode(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_SetRedistributionModeToSplitBoundaryCells(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRedistributionModeToSplitBoundaryCells");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  vtkPVDataRepresentation *temp0 = nullptr;
  int temp1 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkPVDataRepresentation") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->SetRedistributionModeToSplitBoundaryCells(temp0, temp1);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::SetRedistributionModeToSplitBoundaryCells(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_SetRedistributionModeToDuplicateBoundaryCells(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRedistributionModeToDuplicateBoundaryCells");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  vtkPVDataRepresentation *temp0 = nullptr;
  int temp1 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkPVDataRepresentation") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    if (ap.IsBound())
    {
      op->SetRedistributionModeToDuplicateBoundaryCells(temp0, temp1);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::SetRedistributionModeToDuplicateBoundaryCells(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_GetKdTree(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetKdTree");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkPKdTree *tempr = (ap.IsBound() ?
      op->GetKdTree() :
      op->vtkPVRenderViewDataDeliveryManager::GetKdTree());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_RedistributeDataForOrderedCompositing(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RedistributeDataForOrderedCompositing");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->RedistributeDataForOrderedCompositing(temp0);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::RedistributeDataForOrderedCompositing(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_ClearRedistributedData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ClearRedistributedData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->ClearRedistributedData(temp0);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::ClearRedistributedData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_SetOrderedCompositingInformation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOrderedCompositingInformation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  vtkPVDataRepresentation *temp0 = nullptr;
  vtkExtentTranslator *temp1 = nullptr;
  const size_t size2 = 6;
  int temp2[6];
  const size_t size3 = 3;
  double temp3[3];
  const size_t size4 = 3;
  double temp4[3];
  int temp5 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(5, 6) &&
      ap.GetVTKObject(temp0, "vtkPVDataRepresentation") &&
      ap.GetVTKObject(temp1, "vtkExtentTranslator") &&
      ap.GetArray(temp2, size2) &&
      ap.GetArray(temp3, size3) &&
      ap.GetArray(temp4, size4) &&
      (ap.NoArgsLeft() || ap.GetValue(temp5)))
  {
    if (ap.IsBound())
    {
      op->SetOrderedCompositingInformation(temp0, temp1, temp2, temp3, temp4, temp5);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::SetOrderedCompositingInformation(temp0, temp1, temp2, temp3, temp4, temp5);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_SetStreamable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStreamable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  vtkPVDataRepresentation *temp0 = nullptr;
  bool temp1 = false;
  int temp2 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetVTKObject(temp0, "vtkPVDataRepresentation") &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    if (ap.IsBound())
    {
      op->SetStreamable(temp0, temp1, temp2);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::SetStreamable(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_SetNextStreamedPiece(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNextStreamedPiece");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  vtkPVDataRepresentation *temp0 = nullptr;
  vtkDataObject *temp1 = nullptr;
  int temp2 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetVTKObject(temp0, "vtkPVDataRepresentation") &&
      ap.GetVTKObject(temp1, "vtkDataObject") &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    if (ap.IsBound())
    {
      op->SetNextStreamedPiece(temp0, temp1, temp2);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::SetNextStreamedPiece(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_GetCurrentStreamedPiece(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurrentStreamedPiece");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  vtkPVDataRepresentation *temp0 = nullptr;
  int temp1 = 0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1, 2) &&
      ap.GetVTKObject(temp0, "vtkPVDataRepresentation") &&
      (ap.NoArgsLeft() || ap.GetValue(temp1)))
  {
    vtkDataObject *tempr = (ap.IsBound() ?
      op->GetCurrentStreamedPiece(temp0, temp1) :
      op->vtkPVRenderViewDataDeliveryManager::GetCurrentStreamedPiece(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_ClearStreamedPieces(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ClearStreamedPieces");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ClearStreamedPieces();
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::ClearStreamedPieces();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_DeliverStreamedPieces(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DeliverStreamedPieces");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  unsigned int temp0;
  size_t size1 = ap.GetArgSize(1);
  vtkPythonArgs::Array<unsigned int> store1(2*size1);
  unsigned int *temp1 = store1.Data();
  unsigned int *save1 = (size1 == 0 ? nullptr : temp1 + size1);
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1))
  {
    vtkPythonArgs::Save(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->DeliverStreamedPieces(temp0, temp1);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::DeliverStreamedPieces(temp0, temp1);
    }

    if (vtkPythonArgs::HasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_GetRepresentationsReadyToStreamPieces(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRepresentationsReadyToStreamPieces");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  std::vector<unsigned int> temp0(ap.GetArgSize(0));
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0.data(), temp0.size()))
  {
    bool tempr = (ap.IsBound() ?
      op->GetRepresentationsReadyToStreamPieces(temp0) :
      op->vtkPVRenderViewDataDeliveryManager::GetRepresentationsReadyToStreamPieces(temp0));

    if (!ap.ErrorOccurred())
    {
      PyObject *vec = (temp0.size() == 0 ?
        PyTuple_New(0) :
        vtkPythonArgs::BuildTuple(temp0.data(), temp0.size()));
      ap.SetContents(0, vec);
      Py_DECREF(vec);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_GetUseRedistributedDataAsDeliveredData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseRedistributedDataAsDeliveredData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseRedistributedDataAsDeliveredData() :
      op->vtkPVRenderViewDataDeliveryManager::GetUseRedistributedDataAsDeliveredData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_SetUseRedistributedDataAsDeliveredData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseRedistributedDataAsDeliveredData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseRedistributedDataAsDeliveredData(temp0);
    }
    else
    {
      op->vtkPVRenderViewDataDeliveryManager::SetUseRedistributedDataAsDeliveredData(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPVRenderViewDataDeliveryManager_GetDeliveredDataKey(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDeliveredDataKey");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPVRenderViewDataDeliveryManager *op = static_cast<vtkPVRenderViewDataDeliveryManager *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetDeliveredDataKey(temp0) :
      op->vtkPVRenderViewDataDeliveryManager::GetDeliveredDataKey(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPVRenderViewDataDeliveryManager_Methods[] = {
  {"IsTypeOf", PyvtkPVRenderViewDataDeliveryManager_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkPVRenderViewDataDeliveryManager_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkPVRenderViewDataDeliveryManager_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase)\n    -> vtkPVRenderViewDataDeliveryManager\nC++: static vtkPVRenderViewDataDeliveryManager *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkPVRenderViewDataDeliveryManager_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPVRenderViewDataDeliveryManager\nC++: vtkPVRenderViewDataDeliveryManager *NewInstance()\n\n"},
  {"SetDeliverToAllProcesses", PyvtkPVRenderViewDataDeliveryManager_SetDeliverToAllProcesses, METH_VARARGS,
   "V.SetDeliverToAllProcesses(vtkPVDataRepresentation, bool, bool,\n    int)\nC++: void SetDeliverToAllProcesses(vtkPVDataRepresentation *,\n    bool flag, bool low_res, int port=0)\n\nBy default, this class only delivers geometries to nodes that are\ndoing the rendering at a given stage. However, certain\nrepresentations, such as data-label representation, or cube-axes\nrepresentation, need to the geometry to be delivered to all nodes\nalways. That can be done by using this method (via\nvtkPVRenderView::SetDeliverToAllProcesses()).\n"},
  {"SetDeliverToClientAndRenderingProcesses", PyvtkPVRenderViewDataDeliveryManager_SetDeliverToClientAndRenderingProcesses, METH_VARARGS,
   "V.SetDeliverToClientAndRenderingProcesses(vtkPVDataRepresentation,\n     bool, bool, bool, int)\nC++: void SetDeliverToClientAndRenderingProcesses(\n    vtkPVDataRepresentation *, bool deliver_to_client,\n    bool gather_before_delivery, bool low_res, int port=0)\n\nBy default, this class only delivers geometries to nodes that are\ndoing the rendering at a given stage. However, certain\nrepresentations, such as text-source representation, need to the\ngeometry to be delivered to  the client as well.  That can be\ndone by using this method (via\nvtkPVRenderView::SetDeliverToAllProcesses()). The different\nbetween SetDeliverToAllProcesses() and this is that the former\ngather-and-scatters the data on the server nodes, while the\nlatter will optionally gather the data to deliver to the client\nand never scatter.\n"},
  {"MarkAsRedistributable", PyvtkPVRenderViewDataDeliveryManager_MarkAsRedistributable, METH_VARARGS,
   "V.MarkAsRedistributable(vtkPVDataRepresentation, bool, int)\nC++: void MarkAsRedistributable(vtkPVDataRepresentation *,\n    bool value=true, int port=0)\n\nUnder certain cases, e.g. when remote rendering in parallel with\ntranslucent geometry, the geometry may need to be redistributed\nto ensure ordered compositing can be employed correctly. Marking\ngeometry provided by a representation as redistributable makes it\npossible for this class to redistribute the geometry as needed.\nOnly vtkPolyData, vtkUnstructuredGrid or a multi-block comprising\nof vtkPolyData is currently supported.\n"},
  {"SetRedistributionMode", PyvtkPVRenderViewDataDeliveryManager_SetRedistributionMode, METH_VARARGS,
   "V.SetRedistributionMode(vtkPVDataRepresentation, int, int)\nC++: void SetRedistributionMode(vtkPVDataRepresentation *,\n    int mode, int port=0)\n\nFor representations that have indicated that the data is\nredistributable (using MarkAsRedistributable), this control the\nmode for redistribution. Specifically, it indicates how to handle\ncells that are on the boundary of the redistribution KdTree.\nDefault is to split the cells, one can change it to duplicate\ncells instead by using mode as\n`vtkDistributedDataFilter::ASSIGN_TO_ALL_INTERSECTING_REGIONS`.\n"},
  {"SetRedistributionModeToSplitBoundaryCells", PyvtkPVRenderViewDataDeliveryManager_SetRedistributionModeToSplitBoundaryCells, METH_VARARGS,
   "V.SetRedistributionModeToSplitBoundaryCells(\n    vtkPVDataRepresentation, int)\nC++: void SetRedistributionModeToSplitBoundaryCells(\n    vtkPVDataRepresentation *repr, int port=0)\n\nFor representations that have indicated that the data is\nredistributable (using MarkAsRedistributable), this control the\nmode for redistribution. Specifically, it indicates how to handle\ncells that are on the boundary of the redistribution KdTree.\nDefault is to split the cells, one can change it to duplicate\ncells instead by using mode as\n`vtkDistributedDataFilter::ASSIGN_TO_ALL_INTERSECTING_REGIONS`.\n"},
  {"SetRedistributionModeToDuplicateBoundaryCells", PyvtkPVRenderViewDataDeliveryManager_SetRedistributionModeToDuplicateBoundaryCells, METH_VARARGS,
   "V.SetRedistributionModeToDuplicateBoundaryCells(\n    vtkPVDataRepresentation, int)\nC++: void SetRedistributionModeToDuplicateBoundaryCells(\n    vtkPVDataRepresentation *repr, int port=0)\n\nFor representations that have indicated that the data is\nredistributable (using MarkAsRedistributable), this control the\nmode for redistribution. Specifically, it indicates how to handle\ncells that are on the boundary of the redistribution KdTree.\nDefault is to split the cells, one can change it to duplicate\ncells instead by using mode as\n`vtkDistributedDataFilter::ASSIGN_TO_ALL_INTERSECTING_REGIONS`.\n"},
  {"GetKdTree", PyvtkPVRenderViewDataDeliveryManager_GetKdTree, METH_VARARGS,
   "V.GetKdTree() -> vtkPKdTree\nC++: vtkPKdTree *GetKdTree()\n\nProvides access to the partitioning kd-tree that was generated\nusing the data provided by the representations. The view uses\nthis kd-tree to decide on the compositing order when ordered\ncompositing is being used.\n"},
  {"RedistributeDataForOrderedCompositing", PyvtkPVRenderViewDataDeliveryManager_RedistributeDataForOrderedCompositing, METH_VARARGS,
   "V.RedistributeDataForOrderedCompositing(bool)\nC++: void RedistributeDataForOrderedCompositing(bool use_lod)\n\nCalled by the view on every render when ordered compositing is to\nbe used to ensure that the geometries are redistributed, as\nneeded.\n"},
  {"ClearRedistributedData", PyvtkPVRenderViewDataDeliveryManager_ClearRedistributedData, METH_VARARGS,
   "V.ClearRedistributedData(bool)\nC++: void ClearRedistributedData(bool use_load)\n\nRemoves all redistributed data that may have been redistributed\nfor ordered compositing earlier when using KdTree based\nredistribution.\n"},
  {"SetOrderedCompositingInformation", PyvtkPVRenderViewDataDeliveryManager_SetOrderedCompositingInformation, METH_VARARGS,
   "V.SetOrderedCompositingInformation(vtkPVDataRepresentation,\n    vtkExtentTranslator, (int, int, int, int, int, int), (float,\n    float, float), (float, float, float), int)\nC++: void SetOrderedCompositingInformation(\n    vtkPVDataRepresentation *repr,\n    vtkExtentTranslator *translator, const int whole_extents[6],\n    const double origin[3], const double spacing[3], int port=0)\n\nPass the structured-meta-data for determining rendering order for\nordered compositing.\n"},
  {"SetStreamable", PyvtkPVRenderViewDataDeliveryManager_SetStreamable, METH_VARARGS,
   "V.SetStreamable(vtkPVDataRepresentation, bool, int)\nC++: void SetStreamable(vtkPVDataRepresentation *, bool,\n    int port=0)\n\nMark a representation as streamable. Any representation can\nindicate that it is streamable i.e. the view can call streaming\npassses on it and it will deliver data incrementally.\n"},
  {"SetNextStreamedPiece", PyvtkPVRenderViewDataDeliveryManager_SetNextStreamedPiece, METH_VARARGS,
   "V.SetNextStreamedPiece(vtkPVDataRepresentation, vtkDataObject,\n    int)\nC++: void SetNextStreamedPiece(vtkPVDataRepresentation *repr,\n    vtkDataObject *piece, int port=0)\n\nPasses the current streamed piece. This is the piece that will be\ndelivered to the rendering node.\n"},
  {"GetCurrentStreamedPiece", PyvtkPVRenderViewDataDeliveryManager_GetCurrentStreamedPiece, METH_VARARGS,
   "V.GetCurrentStreamedPiece(vtkPVDataRepresentation, int)\n    -> vtkDataObject\nC++: vtkDataObject *GetCurrentStreamedPiece(\n    vtkPVDataRepresentation *repr, int port=0)\n\nPasses the current streamed piece. This is the piece that will be\ndelivered to the rendering node.\n"},
  {"ClearStreamedPieces", PyvtkPVRenderViewDataDeliveryManager_ClearStreamedPieces, METH_VARARGS,
   "V.ClearStreamedPieces()\nC++: void ClearStreamedPieces()\n\nPasses the current streamed piece. This is the piece that will be\ndelivered to the rendering node.\n"},
  {"DeliverStreamedPieces", PyvtkPVRenderViewDataDeliveryManager_DeliverStreamedPieces, METH_VARARGS,
   "V.DeliverStreamedPieces(int, [int, ...])\nC++: void DeliverStreamedPieces(unsigned int size,\n    unsigned int *keys)\n\nDeliver streamed pieces. Unlike regular data, streamed pieces are\ndelivered and released. Representations are expected to manage\nthe pieces once they are delivered to them.\n"},
  {"GetRepresentationsReadyToStreamPieces", PyvtkPVRenderViewDataDeliveryManager_GetRepresentationsReadyToStreamPieces, METH_VARARGS,
   "V.GetRepresentationsReadyToStreamPieces(Stvector_IjE) -> bool\nC++: bool GetRepresentationsReadyToStreamPieces(\n    std::vector<unsigned int> &keys)\n\nFills up the vector with the keys for representations that have\nnon-null streaming pieces.\n"},
  {"GetUseRedistributedDataAsDeliveredData", PyvtkPVRenderViewDataDeliveryManager_GetUseRedistributedDataAsDeliveredData, METH_VARARGS,
   "V.GetUseRedistributedDataAsDeliveredData() -> bool\nC++: virtual bool GetUseRedistributedDataAsDeliveredData()\n\nWhen set to true GetDeliveredDataKey returns\n`REDISTRIBUTED_DATA_KEY` else returns the key returned by\nGetViewDataDistributionMode\n"},
  {"SetUseRedistributedDataAsDeliveredData", PyvtkPVRenderViewDataDeliveryManager_SetUseRedistributedDataAsDeliveredData, METH_VARARGS,
   "V.SetUseRedistributedDataAsDeliveredData(bool)\nC++: virtual void SetUseRedistributedDataAsDeliveredData(\n    bool _arg)\n\nWhen set to true GetDeliveredDataKey returns\n`REDISTRIBUTED_DATA_KEY` else returns the key returned by\nGetViewDataDistributionMode\n"},
  {"GetDeliveredDataKey", PyvtkPVRenderViewDataDeliveryManager_GetDeliveredDataKey, METH_VARARGS,
   "V.GetDeliveredDataKey(bool) -> int\nC++: int GetDeliveredDataKey(bool low_res) override;\n\nViews that support changing of which ranks do the rendering at\nruntime based on things like data sizes, etc. may override this\nmethod to provide a unique key for each different mode. This\nmakes it possible to keep delivered data object for each mode\nseparate and thus avoid transfers if the mode is changed on the\nfly.\n\nDefault implementation simply returns 0.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkPVRenderViewDataDeliveryManager_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkRemotingViews.vtkPVRenderViewDataDeliveryManager", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkPVRenderViewDataDeliveryManager_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPVRenderViewDataDeliveryManager_StaticNew()
{
  return vtkPVRenderViewDataDeliveryManager::New();
}

PyObject *PyvtkPVRenderViewDataDeliveryManager_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkPVRenderViewDataDeliveryManager_Type, PyvtkPVRenderViewDataDeliveryManager_Methods,
    "vtkPVRenderViewDataDeliveryManager",
 &PyvtkPVRenderViewDataDeliveryManager_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPVDataDeliveryManager_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkPVRenderViewDataDeliveryManager(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPVRenderViewDataDeliveryManager_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPVRenderViewDataDeliveryManager", o) != 0)
  {
    Py_DECREF(o);
  }

}

